# Inference of Extended Finite State Machines (Extended_Finite_State_Machine_Inference)

This git repository contains a local mirror of the 
[Archive of Formal Proofs (AFP)](https://www.isa-afp.org) entry 
[*Inference of Extended Finite State Machines*](https://www.isa-afp.org/entries/Extended_Finite_State_Machine_Inference.html).

The official AFP releases are tagged. Additionally, this repository
may contain extensions (i.e., a development version) that may be
submitted, as an update to the existing entry, at a later point in time.

## How to build

```console
achim@logicalhacking:~$ isabelle build -D Extended_Finite_State_Machine_Inference-devel
```

## Authors

* Michael Foster
* [Achim D. Brucker](http://www.brucker.ch/)
* Ramsay G. Taylor
* John Derrick

## License

This project is licensed under a 3-clause BSD-style license.

SPDX-License-Identifier: BSD-3-Clause

## Master Repository

The master git repository for this project is hosted by the [Software
Assurance & Security Research Team](https://logicalhacking.com) at
<https://git.logicalhacking.com/afp-mirror/Extended_Finite_State_Machine_Inference>.

## Publications

* Michael Foster, Achim D. Brucker, Ramsay G. Taylor, Siobhán North, and John Derrick. Incorporating 
  Data into EFSM Inference. In Software Engineering and Formal Methods (SEFM). Lecture Notes in 
  Computer Science (11724), pages 257-272, Springer-Verlag, 2019, 
  doi:[10.1007/978-3-030-30446-1_14](https://doi.org/10.1007/978-3-030-30446-1_14).
  <https://www.brucker.ch/bibliography/abstract/foster.ea-incorporating-2019>

